<?php
/**
 * e107 Helper
 * <p>The main include file for the e107 Helper classes and files.</p>
 * <p>This file simply includes all other required files and should be the only one that
 * a program using
 * e107Helper needs to include.</p>
 * <b>CVS Details:</b>
 * <ul>
 * <li>$Source: e:\_repository\e107_plugins/e107helpers/e107Helper.php,v $</li>
 * <li>$Date: 2006/08/29 22:56:37 $</li>
 * </ul>
 * @author     $Author: Neil $
 * @version    $Revision: 1.13 $
 * @copyright  Released under the terms and conditions of the GNU General Public License
 *             (http://gnu.org).
 * @package    e107Helper
 */

/**
 *
 */

/**
 * This file simply includes all the required files and defines some constants for the e107
 * Helper classes to function.
 * It should be inlcuded using the PHP require_once() function.
 */

   if (!defined("HELPER_INCLUDED_ALREADY")) {
      define("HELPER_INCLUDED_ALREADY",      true);

      if (file_exists(e_PLUGIN."e107helpers/languages/".e_LANGUAGE.".php")) {
         require_once(e_PLUGIN."e107helpers/languages/".e_LANGUAGE.".php");
      } else {
         require_once(e_PLUGIN."e107helpers/languages/English.php");
      }

      /**
       * Constants to be used by applications using the Helper classes
       */
      define("HELPER_TITLE",                 "The e107Helper Project");
      define("HELPER_VER",                   "0.8b");
      define("HELPER_PLUG_FOLDER",           "e107helpers/");

      define("HELPER_FORM_TYPE_NO_BUTTONS",  "0");
      define("HELPER_FORM_TYPE_E107_PREF",   "1");
      define("HELPER_FORM_TYPE_DB_ROW",      "2");

      define("HELPER_RESPONSE_FORM_OK",      "formok");
      define("HELPER_RESPONSE_ACTION",       "action");
      define("HELPER_RESPONSE_ID",           "id");

      define("HELPER_BUTTON_CREATE",         "e107helper_submit_create");
      define("HELPER_BUTTON_SAVE",           "e107helper_submit_save");
      define("HELPER_BUTTON_UPDATE",         "e107helper_submit_update");

      // Admin images
      $imagedir = e_IMAGE."admin_images/";
      if (!defined('HELPER_ICON_EDIT'))      { define("HELPER_ICON_EDIT", "<img src='".$imagedir."edit_16.png' alt='".HELPER_LAN_EDIT."' title='".HELPER_LAN_EDIT."' style='border:0;cursor:pointer;' />"); }
      if (!defined('HELPER_ICON_DELETE'))    { define("HELPER_ICON_DELETE", "<img src='".$imagedir."delete_16.png' alt='".HELPER_LAN_DELETE."' title='".HELPER_LAN_DELETE."' style='border:0;cursor:pointer;' />"); }

      // private use?
      define("HELPER_FORM_MODE_DISPLAY",     0);
      define("HELPER_FORM_MODE_PREF_SAVE",   1);
      define("HELPER_FORM_MODE_DB_CREATE",   2);
      define("HELPER_FORM_MODE_DB_UPDATE",   3);
      define("HELPER_FORM_MODE_DB_EDIT",     4);
      define("HELPER_FORM_MODE_DB_DELETE",   5);

      // Stuff defined by e107 v0.7 we need to define to make things work in 0.617x
      global $IMAGES_DIRECTORY;
      if (!defined("e_IMAGE_ABS"))          define("e_IMAGE_ABS",         e_HTTP.$IMAGES_DIRECTORY);
      if (!defined("e_PLUGIN_ABS"))         define("e_PLUGIN_ABS",        e_HTTP.$PLUGINS_DIRECTORY);

      // Include some e107 files used by this helper classes
      require_once(e_HANDLER."rate_class.php");
      require_once(e_HANDLER."ren_help.php");
      require_once(e_HANDLER."emote.php");

      // Include DHTML calendar class if not already defined
      $incDHTMLCalendarJS = false;
      if (!class_exists("DHTML_Calendar")) {
         if (file_exists(e_HANDLER."calendar/calendar_class.php")) {
            require_once(e_HANDLER."calendar/calendar_class.php");
            $incDHTMLCalendarJS = true;
         }
      }

      // Include Private Message class if not already defined
      if (!class_exists("private_message")) {
         if (file_exists(e_PLUGIN."pm/pm_class.php")) {
            require_once(e_PLUGIN."pm/pm_class.php");
         }
      }

      // Include the e107HelperLogger class if not already defined
      if (!class_exists("e107HelperLogger")) {
         if (file_exists(e_PLUGIN."e107helpers/e107HelperLogger_class.php")) {
            include(e_PLUGIN."e107helpers/e107HelperLogger_class.php");
            $GLOBALS['e107HelperLoggerFactory'] = new e107HelperLoggerFactory();
         } else {
            print "error, cannot find e107HelperLogger class";
         }
      }

      // Include the e107HelperDB class if not already defined
      if (!class_exists("e107HelperDB")) {
         if (file_exists(e_PLUGIN."e107helpers/e107HelperDB_class.php")) {
            include(e_PLUGIN."e107helpers/e107HelperDB_class.php");
         } else {
            print "error, cannot find e107HelperDB class";
         }
      }

      // Include the e107Helper class if not already defined
      if (!class_exists("e107Helper")) {
         if (file_exists(e_PLUGIN."e107helpers/e107Helper_class.php")) {
            include(e_PLUGIN."e107helpers/e107Helper_class.php");
            $GLOBALS['e107Helper'] = new e107Helper();
         } else {
            print "error, cannot find e107Helper class";
         }
      }

      // Include the e107HelperCustomField class if not already defined
      if (!class_exists("e107HelperCustomField")) {
         if (file_exists(e_PLUGIN."e107helpers/e107HelperCustomField_class.php")) {
            include(e_PLUGIN."e107helpers/e107HelperCustomField_class.php");
         } else {
            print "error, cannot find e107HelperCustomField class";
         }
      }

      // Include the e107Helper private class if not already defined
      if (!class_exists("e107HelperPrivate")) {
         if (file_exists(e_PLUGIN."e107helpers/e107Helper_private_class.php")) {
            include(e_PLUGIN."e107helpers/e107Helper_private_class.php");
            $GLOBALS['e107HelperPrivate'] = new e107HelperPrivate();
         } else {
            print "error, cannot find e107HelperPrivate class";
         }
      }

      // Include the e107HelperForm class if not already defined
      if (!class_exists("e107HelperForm")) {
         if (file_exists(e_PLUGIN."e107helpers/e107HelperForm_class.php")) {
            include(e_PLUGIN."e107helpers/e107HelperForm_class.php");
            $GLOBALS['e107HelperForm'] = new e107HelperForm();
         } else {
            print "error, cannot find e107HelperForm class";
         }
      }

      // Include the e107HelperTagObj class if not already defined
      if (!class_exists("e107HelperTagObj")) {
         if (file_exists(e_PLUGIN."e107helpers/e107HelperTagObj_class.php")) {
            include(e_PLUGIN."e107helpers/e107HelperTagObj_class.php");
         } else {
            print "error, cannot find e107HelperTagObj class";
         }
      }

      // Include the e107HelperButtonTagObj class if not already defined
      if (!class_exists("e107HelperButtonTagObj")) {
         if (file_exists(e_PLUGIN."e107helpers/e107HelperButtonTagObj_class.php")) {
            include(e_PLUGIN."e107helpers/e107HelperButtonTagObj_class.php");
         } else {
            print "error, cannot find e107HelperButtonTagObj class";
         }
      }

      // Include the e107HelperStaticTagObj class if not already defined
      if (!class_exists("e107HelperStaticTagObj")) {
         if (file_exists(e_PLUGIN."e107helpers/e107HelperStaticTagObj_class.php")) {
            include(e_PLUGIN."e107helpers/e107HelperStaticTagObj_class.php");
         } else {
            print "error, cannot find e107HelperStaticTagObj class";
         }
      }

      global $e107Helper;
      global $e107HelperForm;
      global $footer_js;

      // Include Javascript helper stuff only if required - to not include it simply define the variable $e107HelperIncludeJS and assign any value
      if (!isset($e107HelperIncludeJS)) {
         //print "\n<!-- e107Helper included files start -->\n";
         print "\n<script type='text/javascript' src='".e_PLUGIN_ABS."e107helpers/e107helper.js'></script>\n";
         if (strpos(e_SELF, "admin_") > 0) {
            // For admin pages
            print "\n<script type='text/javascript' src='".e_FILE_ABS."e_ajax.js'></script>\n";
         } else {
            // For main site pages
            $footer_js[] = e_FILE_ABS.'e_ajax.js';
            //$footer_js[] = e_PLUGIN_ABS."e107helpers/e107helper.js";
            //$footer_js[] = e_PLUGIN_ABS."e107helpers/domTT/domLib.js";
            //$footer_js[] = e_PLUGIN_ABS."e107helpers/domTT/domTT.js";
         }

         if (class_exists("DHTML_Calendar") && $incDHTMLCalendarJS == true) {
            $temp = new DHTML_Calendar();
            //$footer_js[] = $temp->load_files();
            print $temp->load_files();
         }
         //print "\n<!-- e107Helper included files end -->\n";
      }
   }
?>